#include <cstring>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <vector>

using namespace std;

const int tests_start = 13;
const int maxn = 1000;

ofstream out;
int current_test;

int vis[maxn][maxn];

void new_test()
{
    if (current_test >= tests_start) out.close();
    current_test++;
    ostringstream ss;
    ss << setfill('0') << setw(2) << current_test << ".in";
    out.open(ss.str().c_str());
    cout << ss.str() << endl;
}

void gen_random_test(int n, int m)
{
    new_test();
    if (m < 0 || m > n*(n-1)/2)
        cout << "botva" << endl;
    out << n << " " << m << endl;
    if (m == n*(n-1)/2) {
        for (int i = 0; i < n; i++)
            for (int j = i+1; j < n; j++) {
                int u = i, v = j;
                if (rand() % 2) swap(u, v);
                out << u+1 << " " << v+1 << endl;
            }
    } else {
        memset(vis, 0, sizeof(vis));
        for (int i = 0; i < m; i++) {
            int u, v;
            while (1) {
                u = rand() % n;
                v = rand() % n;
                if (u != v && !vis[u][v]) break;
            }
            vis[u][v] = vis[v][u] = 1;
            if (rand() % 2) swap(u, v);
            out << u+1 << " " << v+1 << endl;
        }
    }
}

void main()
{
    current_test = tests_start - 1;
    srand(4357845);
    gen_random_test(5, 4);
    gen_random_test(5, 10);
    gen_random_test(10, 5);
    gen_random_test(10, 10);
    gen_random_test(10, 40);
    gen_random_test(100, 100);
    gen_random_test(100, 1000);
    gen_random_test(1000, 100);
    gen_random_test(1000, 10000);
    gen_random_test(1000, 100001);
    gen_random_test(1000, 499500);
}
